Ensure PDFium resources are ready before loading PDFs

23 Jul 20264 minutes to read

When using the Standalone PDF Viewer, the component downloads the PDFium runtime assets (scripts/wasm) from the path specified in resourceUrl. Calling load() before those assets are ready can fail with a “PDFium not initialized” error or silently leave the viewer blank. Use the resourcesLoaded event to defer document loading until all required assets are ready.

When does resourcesLoaded trigger?

The resourcesLoaded event fires once the viewer finishes loading all required PDFium assets. At this point, it is safe to call the load method to open a document (by URL or Base64). The event fires for the viewer’s asset-load life cycle, not for every document load, so you can call load again later (for example, in response to a user action) without waiting for the event.

How to load a document after resourcesLoaded

  • Set the resourceUrl to a valid PDF Viewer assets path (CDN or a hosted path).
  • Listen to resourcesLoaded and call load inside the handler.
//index.js
import React, { useRef, useCallback } from 'react';
import { createRoot } from 'react-dom/client';
import './index.css';

import {
  PdfViewerComponent,
  Toolbar,
  Magnification,
  Navigation,
  LinkAnnotation,
  ThumbnailView,
  BookmarkView,
  TextSelection,
  Annotation,
  FormDesigner,
  FormFields,
  PageOrganizer,
  Inject
} from '@syncfusion/ej2-react-pdfviewer';

function App() {
  // viewerRef is a stable ref; it does not need to be a useCallback dependency.
  const viewerRef = useRef(null);

  const onResourcesLoaded = useCallback(() => {
    // PDFium assets are ready; it is safe to call load() now.

    // 1) Load by URL (recommended for your case)
    viewerRef.current?.load(
      'https://cdn.syncfusion.com/content/pdf/pdf-succinctly.pdf',
      ''
    );

    // 2) Load by Base64 (uncomment to use).
    // const base64 = 'data:application/pdf;base64,JVBERi0xLjMNCiXi48...';
    // if (base64) {
    //   viewerRef.current?.load(base64, '');
    // }
  }, []);

  return (
    <div style=>
      <PdfViewerComponent
        id="pdfViewer"
        ref={viewerRef}
        resourceUrl="https://cdn.syncfusion.com/ej2/31.2.2/dist/ej2-pdfviewer-lib"
        resourcesLoaded={onResourcesLoaded}
        style=
      >
        <Inject
          services={[
            Toolbar,
            Magnification,
            Navigation,
            LinkAnnotation,
            ThumbnailView,
            BookmarkView,
            TextSelection,
            Annotation,
            FormDesigner,
            FormFields,
            PageOrganizer
          ]}
        />
      </PdfViewerComponent>
    </div>
  );
}

// Mount the app (make sure you have <div id="sample"></div> in index.html).
const container = document.getElementById('sample');
const root = createRoot(container);
root.render(<App />);

View Sample in GitHub

Notes and best practices

  • Always set a valid resourceUrl when using the Standalone PDF Viewer. If the path is incorrect, the event will not fire and load() will fail.
  • If the assets CDN is blocked by the network, the event will not fire. Allow list the asset host (and the document URL host, when applicable) in CORS and CSP settings.
  • Load documents inside resourcesLoaded to guarantee that the PDFium runtime is ready and to prevent intermittent errors on slower networks.

See also

Load a PDF only after PDFium resources are ready in Angular

13 Feb 20263 minutes to read

When using the Standalone PDF Viewer, the component downloads the PDFium runtime assets (scripts/wasm) from the path specified in resourceUrl. Attempting to load a document before those assets are available can cause errors. Use the resourcesLoaded event to defer document loading until all required assets are ready.

When does resourcesLoaded trigger?

The resourcesLoaded event fires once the viewer finishes loading all required PDFium assets. At this point, it is safe to call the load method to open a document (by URL or Base64).

How to load a document after resourcesLoaded

  • Set the resourceUrl to a valid PDF Viewer assets path (CDN or a hosted path).
  • Listen to (resourcesLoaded) and call load inside the handler.
<!-- app.html -->
<ejs-pdfviewer
  #pdfViewer
  id="pdfViewer"
  [resourceUrl]="resourceUrl"
  (resourcesLoaded)="resourcesLoaded()"
  style="height: 640px; display: block"
>
</ejs-pdfviewer>
// app.ts
import { Component, ViewChild } from '@angular/core';
import { PdfViewerComponent, ToolbarService, MagnificationService, NavigationService, LinkAnnotationService, ThumbnailViewService, BookmarkViewService, TextSelectionService, AnnotationService, FormDesignerService, FormFieldsService, PageOrganizerService } from '@syncfusion/ej2-angular-pdfviewer';

@Component({
  selector: 'app-root',
  templateUrl: './app.html',
  providers: [
    ToolbarService,
    MagnificationService,
    NavigationService,
    LinkAnnotationService,
    ThumbnailViewService,
    BookmarkViewService,
    TextSelectionService,
    AnnotationService,
    FormDesignerService,
    FormFieldsService,
    PageOrganizerService
  ],
  styleUrls: ['app.css'],
  standalone: true,
  imports: [PdfViewerModule],
})
export class AppComponent {
  @ViewChild('pdfViewer') 
  public pdfViewer!: PdfViewerComponent;

  // Point to the PDF Viewer assets (scripts/wasm) location
  public resourceUrl = 'https://cdn.syncfusion.com/ej2/31.2.2/dist/ej2-pdfviewer-lib';

  // Sample sources to demonstrate both URL and Base64 loading
  public documentUrl = 'https://cdn.syncfusion.com/content/pdf/pdf-succinctly.pdf';
  public base64: string = '';// supply your Base64 here when needed

  // Called by the (resourcesLoaded) event
  public resourcesLoaded(): void {
    // Choose ONE of the following load options:

    // 1) Load by URL
    this.pdfViewer.load(this.documentUrl, "");

    // 2) Load by Base64 (uncomment if you want to load Base64)
    // if (this.base64) {
    //   this.pdfViewer.load(`data:application/pdf;base64,${this.base64}`, "");
    // }
  }
}

View Sample in GitHub

Notes and best practices

  • Always set a valid resourceUrl when using the Standalone PDF Viewer. If the path is incorrect or blocked by the network, the event cannot fire.
  • Load documents inside resourcesLoaded. This guarantees the PDFium runtime is ready and prevents intermittent errors on slower networks.
  • The event fires for the viewer’s asset load life cycle, not for every document load. After it fires once, you can safely call load again later (for example, in response to user actions) without waiting for the event.

See also

Load a PDF only after PDFium resources are ready

28 Feb 20263 minutes to read

When using the Standalone PDF Viewer, the component downloads the PDFium runtime assets (scripts/wasm) from the path specified in resourceUrl. Attempting to load a document before those assets are available can cause errors. Use the resourcesLoaded event to defer document loading until all required assets are ready.

When does resourcesLoaded trigger?

The resourcesLoaded event fires once the viewer finishes loading all required PDFium assets. At this point, it is safe to call the load method to open a document (by URL or Base64).

How to load a document after resourcesLoaded

  • Set the resourceUrl to a valid PDF Viewer assets path (CDN or a hosted path).
  • Listen to (resourcesLoaded) and call load inside the handler.
<!-- App.vue -->
<template>
  <div id="app">
    <ejs-pdfviewer
      id="pdfViewer"
      ref="pdfviewer"
      :documentPath="documentPath"
      :resourceUrl="resourceUrl"
      @resourcesLoaded="onResourcesLoaded"
      style="height: 640px;"
    >
    </ejs-pdfviewer>
  </div>
</template>

<script>
import {
  PdfViewerComponent,
  Toolbar,
  Magnification,
  Navigation,
  Annotation,
  TextSelection,
  TextSearch,
  FormFields,
  FormDesigner,
  PageOrganizer,
} from '@syncfusion/ej2-vue-pdfviewer';

export default {
  name: 'App',
  components: {
    'ejs-pdfviewer': PdfViewerComponent,
  },
  data() {
    return {
        documentPath:'https://cdn.syncfusion.com/content/pdf/pdf-succinctly.pdf',
        resourceUrl: 'https://cdn.syncfusion.com/ej2/28.1.33/dist/ej2-pdfviewer-lib'
    };
  },
  provide: {
    PdfViewer: [
      Toolbar,
      Magnification,
      Navigation,
      Annotation,
      TextSelection,
      TextSearch,
      FormFields,
      FormDesigner,
      PageOrganizer,
    ],
  },
    methods: {
    onResourcesLoaded() {
      // Choose ONE of the following load options:

      // 1) Load by URL
      this.$refs.pdfviewer?.load(this.documentPath, '');

      // 2) Load by Base64 (uncomment if you want to load Base64)
      // const base64 ='data:application/pdf;base64,JVBERi0xLjMNCiXi48...';
      // if (base64) {
      //   this.$refs.viewer?.load(base64, '');
      // }
    }
  },
};
</script>

View sample in GitHub

Notes and best practices

  • Always set a valid resourceUrl when using the Standalone PDF Viewer. If the path is incorrect or blocked by the network, the event cannot fire.
  • Load documents inside resourcesLoaded. This guarantees the PDFium runtime is ready and prevents intermittent errors on slower networks.
  • The event fires for the viewer’s asset load life cycle, not for every document load. After it fires once, you can safely call load again later (for example, in response to user actions) without waiting for the event.

See also